<template>
  <Row class="manager-user-detail">
    <i-col class="step-block content-block" :span="8">
      <Row class="image-block">
        <div class="user-image-back-circle">
          <div class="user-image" :style="{backgroundImage}"></div>
        </div>
      </Row>
      <Row class="step-list">
        <div class="steps">
          <div v-for="(step, index) in steps" :key="index"
              class="step-item" :ref="step.key">
            <div class="dot" :style="dotStyle(step.key)"></div>
            <div class="label">{{step.label}}</div>
          </div>
        </div>
        <Row class="btn-block">
          <template v-if="toRegister">
            <Button type="info" @click="submitAction">Register</Button>
          </template>
        </Row>
      </Row>
    </i-col>

    <i-col class="form-block content-block" :span="16">
      <!-- Basic Information -->
      <template v-if="toView">
        <stock-form title="Basic Information">
          <stock-form-item v-for="(field, index) in schemaFields(basicInfoForm.schema)" :key="field"
                          :value="basicInfoForm.data[field]"
                          :options="basicInfoForm.schema[field]">
          </stock-form-item>
        </stock-form>
      </template>

      <!-- Register -->
      <template v-if="toRegister">
        <stock-form title="Register">
          <stock-form-item v-for="(field, index) in schemaFields(registerForm.schema)" :key="field"
                          v-model="registerForm.data[field]"
                          :options="registerForm.schema[field]"
                          :error="registerForm.error[field]"
                          :edit="true">
          </stock-form-item>
          <Row>
            <i-col class="role-block" :lg="12" :md="12">
              <div class="role-item" :class="[registerUserTypeStyle(1)]"
                  @click="selectUserTypeAction(1)">
                <div class="manager-btn div-btn">
                  <Icon type="md-settings"></Icon>
                </div>
                <div> Manager </div>
              </div>
            </i-col>

            <i-col class="role-block" :lg="12" :md="12">
              <div class="role-item" :class="[registerUserTypeStyle(2)]"
                  @click="selectUserTypeAction(2)">
                <div class="user-btn div-btn">
                  <Icon type="md-person"></Icon>
                </div>
                <div> User </div>
              </div>
            </i-col>
          </Row>
        </stock-form>
      </template>
    </i-col>
  </Row>
</template>

<script>
  import StockFormItem from "../../../../components/StockFormItem";
  import * as form from '../../../../helpers/form';
  import StockForm from '../../../../components/StockForm';
  import { apiRoot } from '../../../../configs/api';
  import { basicForm } from "../../../../helpers/form";
  import { validators as api } from '../../../../configs/request-validator/user';

  const actions = {
    selectUserTypeAction(type) {
      this.userType = type;
    },
    async submitAction() {
      try {
        const createManager = this.userType === 1;
        const { status, code } = (createManager)
          ? await this.$api(api.CreateUserRequest, this.registerForm.data, 'manager')
          : await this.$api(api.CreateUserRequest, this.registerForm.data, 'user');
        const isSuccess = status && code === 200;
        if (isSuccess) {
          this.$redirectTo('manager-user');
        }
      } catch (error) {
        this.$apiErrorHandler(error);
      }
    },
  };

  export default {
    name: 'index',
    mixins: [form.mixin],
    components: { StockForm, StockFormItem},
    data() {
      return {
        steps: [
          { key: 0, label: 'Basic Information' },
        ],
        currentStep: 0,
        // form
        toRegister: undefined,
        toView: undefined,
        userId: undefined,
        profileImageURL: undefined,
        edit: false,
        basicInfoForm: undefined,
        registerForm: undefined,
        userType: 2, // 0: dev, 1: manager, 2: user
      };
    },
    computed: {
      backgroundImage() {
        return `url(${this.profileImageURL})`;
      },
    },
    methods: {
      ...actions,
      dotStyle(key) {
        const isCurrentStep = this.currentStep === key;
        return (isCurrentStep)
          ? {
            width: '20px',
            height: '20px',
            borderRadius: '11px',
            left: '-26px',
            top: '12px',
            backgroundColor: '#3de1ff',
          }
          : {};
      },
      registerUserTypeStyle(type) {
        return (this.userType === type) ? 'checked' : '' ;
      }
    },
    mounted() {
      this.$displayBodyBlock(false);
    },
    async asyncData({ app, params, redirect }) {
      const userId = Number(params['id']);
      const toRegister = userId === -1;
      const toView = !toRegister;
      let basicInfoForm = undefined;
      let registerForm = undefined;
      let loginUser = {};

      if (toRegister) {
        registerForm = {
          ...basicForm,
          schema: {
            name: { type: 'text', title: 'Name' },
            email: { type: 'text', title: 'Email' },
            phone: { type: 'text', title: 'Phone' },
            password: { type: 'password', title: 'Password' },
            password_confirmation: { type: 'password', title: 'Confirm Password' },
          },
          rules: api.CreateUserRequest.body,
          data: {
            name: undefined,
            email: undefined,
            phone: undefined,
            password: undefined,
            password_confirmation: undefined,
          }
        };
      } else {
        // request
        const getUserRequest = { userId };

        // invoke api
        try {
          const response = await Promise.all([
            app.$api(api.AccessUserRequest, getUserRequest, undefined, false),
          ]);
          loginUser = response[0]['data'];
        } catch (error) {
          redirect('/manager/user');
        }

        basicInfoForm = {
          ...form.basicForm,
          schema: {
            name: { type: 'text', title: 'Account' },
            email: { type: 'text', title: 'Email' },
            phone: { type: 'text', title: 'Phone Number' },
            createdAt: { type: 'text', title: 'Join At' },
          },
          data: loginUser,
        };
      }

      return {
        toRegister,
        toView,
        userId: loginUser['id'],
        profileImageURL: loginUser['image']
          ? `${apiRoot}/v1${loginUser['image']}`
          : 'https://i.ytimg.com/vi/s7_2vC7BoCs/maxresdefault.jpg',
        basicInfoForm,
        registerForm,
      };
    },
  }
</script>

<style lang="scss" scoped>
  @import '../../../../assets/css/mixin';

  .manager-user-detail {
    height: 100%;
    .content-block {
      height: 100%;
      overflow-y: auto;
    }
    .step-block {
      overflow: hidden;
      &::before {
        content: "";
        position: absolute;
        width: 100%;
        height: 100%;
        top: 3%;
        right: -28%;
        z-index: -1;
        background: url("/images/horn-background.png") 0 0 no-repeat;
        background-size: contain;
        transform: rotate(-23deg);
      }
      .image-block {
        position: relative;
        top: 150px;
        text-align: center;
        text-align: -webkit-center;
        cursor: pointer;
        .user-image-back-circle {
          position: relative;
          width: 130px;
          height: 130px;
          padding: 5px;
          border-radius: 71px;
          text-align: center;
          .user-image {
            width: 120px;
            height: 120px;
            border-radius: 61px;
            background-size: cover;
            background-repeat: no-repeat;
            background-position: center;
          }
        }
      }
      .step-list {
        top: 200px;
        text-align: center;
        text-align: -webkit-center;
        .steps {
          .step-item {
            text-align: left;
            width: 190px;
            height: 50px;
            padding: 10px 15px;
            line-height: 30px;
            vertical-align: middle;
            font-size: 16px;
            font-weight: bold;
            cursor: pointer;
            .dot {
              position: relative;
              top: 10px;
              left: -24px;
              width: 16px;
              height: 16px;
              border-radius: 9px;
            }
            .label {
              position: relative;
              top: -12px;
              margin-left: 10px;
            }
          }
        }
        .btn-block {
          margin: 60px 0;
        }
      }
    }
    .form-block {
      padding: 80px 100px;
      .role-block {
        text-align: center;
        .role-item {
          width: 60%;
          padding: 10px 15px;
          margin: 0 20%;
          .manager-btn {
            @include circle-div-btn(60);
          }
          .user-btn {
            @include circle-div-btn(60);
          }
        }
        .role-item.checked {
          border-radius: 6px;
        }
      }
    }
  }
</style>
